=== debian/changelog ===
xen (4.20.2-1+ub24u04.2) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 75013fc5c523b8a969
    x86/amd: Fold another DE_CFG edit into amd_init_de_cfg-Thu 29 Jan 2026 04:45
  - XSA-477
    0021-x86-shadow-don-t-overrun-trace_emul_write_val.diff:This is XSA-477 / CVE-2025-58150.
  - XSA-479
    0022-x86-spec-ctrl-Fix-incomplete-IBPB-flushing-during-con.diff:This is XSA-479 / CVE-2026-23553.

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 29 Jan 2026 14:06:56 -0800

xen (4.20.2-1+ub24u04.1) noble; urgency=medium

  * HEAD @ 0cb467d86df393fc2c
    x86: fix incorrect return value for has_if_pschange_mc-Tue 13 Jan 2026 06:47
  * initial build of 4.20.2
  * XSA-475
    0050-x86-viridian-Enforce-bounds-check-in-vpmask_set.diff:This is XSA-475 / CVE-2025-58147.
    0051-x86-viridian-Enforce-bounds-check-in-send_ipi.diff:This is XSA-475 / CVE-2025-58148.
  * XSA-476
    0053-tools-libs-light-fix-BAR-memory-address-truncation.diff:This is XSA-476 / CVE-2025-58149.
  * qemuu: support opengl & dbus-display

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 22 Jan 2026 20:28:44 -0800

xen (4.20.1-1+ub24u04.3) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ ae992e68d3ed7a177
    CI: Create initrd fragments explicitly as root-Wed 10 Sep 2025 09:19
  * XSA-472
    0035-x86-viridian-avoid-NULL-pointer-dereference-in-update.diff:This is CVE-2025-27466 / part of XSA-472.
    0036-x86-viridian-avoid-NULL-pointer-dereference-in-viridi.diff:This is CVE-2025-58142 / part of XSA-472.
    0037-x86-viridian-protect-concurrent-modification-of-the-r.diff:This is CVE-2025-58143 / part of XSA-472.
  * XSA-473
    0038-Arm-foreign-page-handling-in-p2m_get_page_from_gfn.diff:This is CVE-2025-58144 / part of XSA-473.
    0039-Arm-adjust-locking-in-p2m_get_page_from_gfn.diff:This is CVE-2025-58145 / part of XSA-473.

 -- Mark Pryor <pryorm09@gmail.com>  Wed, 17 Sep 2025 11:11:06 -0700

xen (4.20.1-1+ub24u04.2) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 69568ab30622ba09a398
    x86/S3: dont lose previously collected CPU data (AMD extra)-Tue 22 Jul 2025 03:42

 -- Mark Pryor <pryorm09@gmail.com>  Tue, 22 Jul 2025 12:32:51 -0700

xen (4.20.1-1+ub24u04.1) noble; urgency=medium

  * HEAD @ 08f043965a7b1047a
    update Xen version to 4.20.1-Wed 9 Jul 2025 06:57
  * initial build of xen-4.20.1
  * XSA-471
    0138-x86-ucode-Digests-for-TSA-microcode.diff:This is part of XSA-471 / CVE-2024-36350 / CVE-2024-36357.
    0139-x86-idle-Rearrange-VERW-and-MONITOR-in-mwait_idle_wit.diff:This is part of XSA-471 / CVE-2024-36350 / CVE-2024-36357.
    0140-x86-spec-ctrl-Mitigate-Transitive-Scheduler-Attacks.diff:This is part of XSA-471 / CVE-2024-36350 / CVE-2024-36357.
  * XSA-470
    9e1309b0f037a6-x86/emul: Fix extable registration in invoke_stub-Tue 1 Jul 2025 04:57
  * all *efi blobs to usr/lib/efi, not ESP

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 10 Jul 2025 13:46:09 -0700

xen (4.20.0-1+ub24u04.5) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ ddec00769cd80a44
    x86/emul: Fix emulation of RDSEED with older toolchains-Fri 16 May 2025 13:34
  * d/control: xen-perf-hypervisor, new package
  * XSA-469
    0100-x86-guest-Remove-use-of-the-Xen-hypercall_page.diff:This is part of XSA-469 / CVE-2024-28956
    0101-x86-thunk-Mis-align-__x86_indirect_thunk_-to-mitigate.diff:This is part of XSA-469 / CVE-2024-28956
    0102-x86-thunk-Mis-align-the-RETs-in-clear_bhb_loops-to-mi.diff:This is part of XSA-469 / CVE-2024-28956
    0103-x86-stubs-Introduce-place_ret-to-abstract-away-raw-0x.diff:This is part of XSA-469 / CVE-2024-28956
    0104-x86-thunk-Build-Xen-with-Return-Thunks.diff:This is part of XSA-469 / CVE-2024-28956
    0105-x86-spec-ctrl-Synthesise-ITS_NO-to-guests-on-unaffect.diff:This is part of XSA-469 / CVE-2024-28956

 -- Mark Pryor <pryorm09@gmail.com>  Mon, 23 Jun 2025 08:42:34 -0700

xen (4.20.0-1+ub24u04.4) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 35cb38b2220b15e122
    x86: constrain sub-page access length in mmio_ro_emulated_write-Tue 29 Apr 2025 11:47

 -- Mark Pryor <pryorm09@gmail.com>  Tue, 29 Apr 2025 17:53:46 -0700

xen (4.20.0-1+ub24u04.3) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ c607822b5ae946cfc2
    x86/setup: correct off-by-1 in module mapping-Thu 20 Mar 2025 04:55

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 20 Mar 2025 20:04:56 -0700

xen (4.20.0-1+ub24u04.2) noble; urgency=medium

  * remove t64 names, now out-of-transition
    applies to all noble 4.20 xen packages, from here on out

 -- Mark Pryor <pryorm09@gmail.com>  Sun, 09 Mar 2025 09:16:45 -0800

xen (4.20.0-1+ub24u04.1) noble; urgency=medium

  * HEAD @ 3ad5d648cda5add395f
    Update to Xen 4.20-Tue 4 Mar 2025 08:41
  * initial build of 4.20.0
  * XSA-467
    0557-IOMMU-x86-the-bus-to-bridge-lock-needs-to-be-acquired.diff:This is XSA-467 / CVE-2025-1713.

 -- Mark Pryor <pryorm09@gmail.com>  Tue, 04 Mar 2025 17:56:03 -0800

xen (4.20~rc5-1+ub24u04.1) noble; urgency=medium

  * HEAD @ ac8198c532f4e39659d5e5
    Switch to release builds by default-Fri 21 Feb 2025 06:58

 -- Mark Pryor <pryorm09@gmail.com>  Sat, 22 Feb 2025 15:32:09 -0800

xen (4.20~rc2-1+ub24u04.1) noble; urgency=medium

  * HEAD @ 39c45caef271bc2b
    xen/arm: ffa: fix bind/unbind notification-Mon 3 Feb 2025 14:48
  * 4.20 initial rc build
  * qemuu: v9.1.0

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 06 Feb 2025 12:26:43 -0800
