## xen 4.20.2%2B7-g1badcf5035

=== debian/changelog ===
xen (4.20.2+7-g1badcf5035-0+deb13u1) trixie-security; urgency=medium

  Significant changes:
  * Update to new upstream version 4.20.2+7-g1badcf5035, which also contains
    security fixes for the following issues:
    (Closes: #1105193) (Closes: #1120075)
    - x86: Indirect Target Selection
      XSA-469 CVE-2024-28956
    - x86: Incorrect stubs exception handling for flags recovery
      XSA-470 CVE-2025-27465
    - x86: Transitive Scheduler Attacks
      XSA-471 CVE-2024-36350 CVE-2024-36357
    - Multiple vulnerabilities in the Viridian interface
      XSA-472 CVE-2025-27466 CVE-2025-58142 CVE-2025-58143
    - Arm issues with page refcounting
      XSA-473 CVE-2025-58144 CVE-2025-58145
    - x86: Incorrect input sanitisation in Viridian hypercalls
      XSA-475 CVE-2025-58147 CVE-2025-58148
    - Incorrect removal of permissions on PCI device unplug
      XSA-476 CVE-2025-58149
  * Note that the following XSA are not listed, because...
    - XSA-468 applies to Windows PV drivers
    - XSA-474 applies to XAPI which is not included in Debian

  Packaging minor fixes and improvements:
  * debian/salsa-ci.yml: adjust for trixie and new salsa-ci pipeline

 -- Maximilian Engelhardt <maxi@daemonizer.de>  Sun, 30 Nov 2025 16:57:07 +0100
